
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>数据结构之深度优先，广度优先遍历 / 憋错料</title>

    <meta name="description" content="数据结构之深度优先，广度优先遍历 深度优先和广度优先遍历在树和图中应用最为普遍,思想也类似,因此放到一起来总结. 二叉树的深度优先广度优先遍历: 一棵二叉树(2,(2(3,4),3(4,5))),这是一棵满二叉树,一共有7个节点,根节点2,深度为3 数据结构定义如下: class Node: def __init__(self, value=None, left = None, right = None): self.value = value self.left = left self.right = right 先根遍历 d">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">数据结构之深度优先，广度优先遍历</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>深度优先和广度优先遍历在树和图中应用最为普遍，思想也类似，因此放到一起来总结。</p>
<h2>二叉树的深度优先广度优先遍历：</h2>
<p>一棵二叉树(2,(2(3,4),3(4,5)))，这是一棵满二叉树，一共有7个节点，根节点2，深度为3</p>
<p>数据结构定义如下：</p>
<pre>class Node:
	def __init__(self, value=None, left = None, right = None):
		self.value = value
		self.left = left
		self.right = right
</pre>
<p>先根遍历</p>
<pre>def preTraverse(tree):
	if(tree):
		print tree.value
		preTraverse(tree.left)
		preTraverse(tree.right)
</pre>
<p>后根遍历与中根遍历类似，就不写了，用的都是深度优先遍历</p>
<p>层序遍历，用的是广度优先遍历，需要额外一个队列作为临时变量保存每层的节点</p>
<pre>def hiraTraverse(tree, queue_node):
	if len(queue_node)==0 &amp; (tree is None):
		queue_node.append(tree)
	while len(queue_node)&gt;0:
		node = queue_node.pop(0)
		print node.value
		if not node.left is None:
			queue_node.append(node.left)
		if not node.right is None:
			queue_node.append(node.right)
</pre>
<p>图的深度优先广度优先遍历：</p>
<p>图常用的存储方式包括邻接矩阵，邻接表等，这里以邻接矩阵为例</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 07:09:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>数据结构之深度优先，广度优先遍历的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/026ADA0.html" rel="bookmark">数据结构课设&mdash;&mdash;有向图的深度、广度优先遍历及拓扑排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				任务:给定一个有向图,实现图的深度优先, 广度优先遍历算法,拓扑有序序列,并输出相关结果. 功能要求:输入图的基本信息,并建立图存储结构(有相应提示),输出遍历序列,然后进行拓扑排序,并测试该图是否为有向无环图,并输出拓扑序列. 按照惯例,先上代码,注释超详细: #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; #include&lt;malloc.h&gt; #pragma warning(disable:4996) #define Max 20//定义数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rOvOg4.html" rel="bookmark">数据结构：图的遍历--深度优先、广度优先</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图的遍历:深度优先.广度优先 遍历 图的遍历是指从图中的某一顶点出发,按照一定的策略访问图中的每一个顶点.当然,每个顶点有且只能被访问一次. 在图的遍历中,深度优先和广度优先是最常使用的两种遍历方式.这两种遍历方式对无向图和有向图都是适用的,并且都是从指定的顶点开始遍历的.先看下两种遍历方式的遍历规则: 深度优先 深度优先遍历也叫深度优先搜索(Depth First Search).它的遍历规则:不断地沿着顶点的深度方向遍历.顶点的深度方向是指它的邻接点方向. 具体点,给定一图G=&lt;V,E&gt;,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm156YM.html" rel="bookmark">数据结构--图--图的数组存储表示&comma;深度优先搜索遍历和广度优先搜索遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图有四种存储结构:数组,邻接表,十字链表,邻接多重表.下面以数组为存储结构来实现图的深度优先搜索遍历和广度优先搜索遍历.其中广度优先搜索遍历中有用到STL中的queue,注意头文件的包含.具体代码如下: //图的数组(邻接矩阵)存储表示和深度优先遍历 const int MAX_VERTEX_NUM=20; //最大顶点数 typedef enum {DG,DN,UDG,UDN} GraphKind ;//(有向图,有向网,无向图,无向网) typedef int VRType; typedef			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QWB820.html" rel="bookmark">树的深度优先遍历和广度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 import java.util.ArrayDeque; 2 3 public class BinaryTree { 4 static class TreeNode{ 5 int value; 6 TreeNode left; 7 TreeNode right; 8 9 public TreeNode(int value){ 10 this.value=value; 11 } 12 } 13 14 TreeNode root; 15 16 public BinaryTree(int[] ar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OaZ9PM.html" rel="bookmark">二叉树遍历（前序、中序、后序、层次、深度优先、广度优先遍历）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				二叉树是一种非常重要的数据结构,很多其它数据结构都是基于二叉树的基础演变而来的.对于二叉树,有深度遍历和广度遍历,深度遍历有前序.中序以及后序三种遍历方法,广度遍历即我们平常所说的层次遍历.因为树的定义本身就是递归定义,因此采用递归的方法去实现树的三种遍历不仅容易理解而且代码很简洁,而对于广度遍历来说,需要其他数据结构的支撑,比如堆了.所以,对于一段代码来说,可读性有时候要比代码本身的效率要重要的多. 四种主要的遍历思想为: 前序遍历:根结点 ---&gt; 左子树 ---&gt; 右子树 中序遍历:左子			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmDvJP4.html" rel="bookmark">树的深度优先与广度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简述树的深度优先及广度优先遍历算法,并说明非递归实现. 原题出自百度的笔试: 当时我看到这个题目的时候,已经完全记不得非递归算法该怎么实现了,后来查阅了一下,要用到两个辅助的数据结构: 深度优先遍历---&gt;栈: 广度优先遍历---&gt;队列: 这里以二叉树为例来实现. import java.util.ArrayDeque; public class BinaryTree { static class TreeNode{ int value; TreeNode left; TreeNode rig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MymzneM.html" rel="bookmark">以邻接表作为存储结构的图的深度优先遍历和广度优先遍历（c&plus;&plus;版&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.图的存储 用邻接表法存储图,存储结构分为两部分,一部分为存储图的所有顶点的数组,另一部分为挂载在数组的每个元素后面的用来表示顶点的邻接点的链表. 1.存储顶点的结构单元为: class vnode { public: string nodename; bool visted;//进行图的遍历时用于标记图是否被访问过 node *next; vnode() { visted = false; next = NULL; } }; 链表的结构单元为: class node { public: st			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBxEkv3.html" rel="bookmark">图的广度优先遍历和深度优先遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图是一种很重要的数据结构,在我们的编程生活中应用极其广泛 #include &lt;iostream&gt; using namespace std; #define INFINITY 32767 #define MAX_VEX 20 //最大顶点个数 #define QUEUE_SIZE (MAX_VEX+1) //队列长度 bool *visited; //访问标志数组 //图的邻接矩阵存储结构 typedef struct { char *vexs; //顶点向量 int arcs[MAX_VEX]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLve6B3.html" rel="bookmark">存储结构与邻接矩阵，深度优先和广度优先遍历及Java实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果看完本篇博客任有不明白的地方,可以去看一下&lt;大话数据结构&gt;的7.4以及7.5,讲得比较易懂,不过是用C实现 下面内容来自segmentfault 存储结构 要存储一个图,我们知道图既有结点,又有边,对于有权图来说,每条边上还带有权值.常用的图的存储结构主要有以下二种: 邻接矩阵 邻接表 邻接矩阵 我们知道,要表示结点,我们可以用一个一维数组来表示,然而对于结点和结点之间的关系,则无法简单地用一维数组来表示了,我们可以用二维数组来表示,也就是一个矩阵形式的表示方法. 我们假设A是这个二维数组			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMglkB0.html" rel="bookmark" class="title">HDU 5225</a>
					<div>
						求逆序的个数.首先处理出对n个数它所有排列的逆序的个数.然后,按位枚举,当枚举的数少于当前位,逆序数的个数就是前面确定的数对于后面数的逆序总数+后面k个数的排列的逆序总数. 1Y. #include& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrEaR0.html" rel="bookmark" class="title">iOS中RGB颜色转换</a>
					<div>
						iOS中RGB常用的色值,同时可将对颜色的设置定义成宏,方便开发应用,如: // RGB颜色转换(16进制-&gt;10进制) #define UIColorFromRGB(rgbValue) [UI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0byJG9M.html" rel="bookmark" class="title">BZOJ 1976 能量魔方 Cube（最小割）</a>
					<div>
						题目链接:http://61.187.179.132/JudgeOnline/problem.php?id=1976 题意:给出一个n*n*n的立方体.每个小单位为字母P或者字母N.相邻两个小单位字母 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywvLA3.html" rel="bookmark" class="title">java toString</a>
					<div>
						package com.mydemo.controller; // 1.getClass().getName() + '@' + Integer.toHexString(hashCode()) pub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5aa7M.html" rel="bookmark" class="title">SSH通过超链接传递中文参数出现乱码问题</a>
					<div>
						通过超链接传递中文参数出现乱码问题 tomcat中的server.xml文件中修改如下配置: &lt;Connector port=&quot;8080&quot; protocol=&quot;HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nzq1y4.html" rel="bookmark" class="title">LEXUS OPENCART 自适应主题模板 ABC-0019-01 HIGHLIGHTED FEA</a>
					<div>
						LEXUS OPENCART 自适应主题模板 ABC-0019-01 HIGHLIGHTED FEATURES FLEXIBLE LAYOUTS – MODULES FEATURES Compatib ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5Pl84.html" rel="bookmark" class="title">mybatis介绍与环境搭建</a>
					<div>
						一.不用纯jdbc的原因,即缺点. 1.数据库理解,使用时创建,不用时释放,会对数据库进行频繁的链接开启和关闭,造成数据库的资源浪费,影响数据库的性能.设想:使用数据库的连接池.2.将sql语句硬编码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvkBz4.html" rel="bookmark" class="title">最后一次作业，完结撒花~</a>
					<div>
						很开心!终于第八周了!项目终于完成了!答辩也完了! 总结一下前八周的成果大概就是: 1.做网页设计 2.写代码 3.改代码 4.写文档 5.改代码 6.改……代……码 7.代码终于改完了QAQ 讲道理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAYZQ4.html" rel="bookmark" class="title">TP-LINK telnet远程 重启路由器（转）</a>
					<div>
						突然断网,以前房东的路由器管理页面可以打开,今天突然间就打不开了.ping了下,可以ping通,于是就想起了房东的路由器是TP-LINK的 可以 telnet登陆的.每次,断网,我都会重启房东的路由器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvKy13.html" rel="bookmark" class="title">Web开发的入门指导</a>
					<div>
						Web开发的入门指导 web开发 编程技术 你点开此文,说明你对Web开发是有兴趣的,或者你正在思考开始学习Web开发.在这里,我会告诉你成为一名Web开发者的路线,是对初学者关于Web开发的指导.这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wEWbQM.html" rel="bookmark" class="title">【信息安全系列】AIX主机安全检查脚本</a>
					<div>
						#!/bin/ksh ########################################################## ## ## ## It was used for AIX O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkgYX4.html" rel="bookmark" class="title">backbone之extend方法（刚明白了点）</a>
					<div>
						话说这个extend困扰我好几天了,今天终于想明白了点. 在之前先要知道什么是实例方法和静态方法. 首先定义一个类(js不支持类,但是别人都这么说,我也不知道为啥),如:var Person=func ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbQ5l3.html" rel="bookmark" class="title">Windows服务器本地用户、组的管理</a>
					<div>
						1   新建用户的创建如下: 2  新建用户组的创建如下:3   批量组建用户的建立 以上是我的学习收获.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvLvB3.html" rel="bookmark" class="title">HDU2082 找单词</a>
					<div>
						母函数 #include&lt;cstdio&gt; #include&lt;string.h&gt; #define min(a,b) ((a)&lt;(b)?(a):(b)) int N,v[26 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjbzEM.html" rel="bookmark" class="title">AvAudioPlayer</a>
					<div>
						AvAudioPlayer类是编写iOS播放器的三个类之一,其他两个以后用到再阐述.今天的主角是AvAudioPlayer. 首先介绍一下,AvAudioPlayer它是苹果公司封装好的一个类,用起来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPP9bM.html" rel="bookmark" class="title">jsoupa-解析遍历一个HTML</a>
					<div>
						解析个遍历一个HTML文档 String html =&quot;&lt;html&gt;&lt;head&gt;&lt;title&gt;First parse&lt;/title&gt;&lt;/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35Pm520.html" rel="bookmark" class="title">lamp优化</a>
					<div>
						LAMP搭建 1.apache集成了php模块,apache和php相对于一个东西. yum  install httdp -y yum  install php -y yum install  my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6l2a3.html" rel="bookmark" class="title">买保险</a>
					<div>
						本文来自我根据自身情况,对 李元霸--如何用保险保障自己的一生 进行的总结. 保险的作用: 打个比方,没买保险前,你未来财富现值的范围可能是 [-50万元, 200万元],有负值的原因可能是各种财富损 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ralXb0.html" rel="bookmark" class="title">可以用JS判断客服QQ号在线还是离线状态的程序</a>
					<div>
						&lt;pre name=&quot;code&quot; class=&quot;html&quot;&gt;不知道从什么时候开始,原来QQ官方自带的在线离线状态的代码已经不能准确显示在线或离线状态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Ok5Ro3.html" rel="bookmark" class="title">Linux下开启FTP服务</a>
					<div>
						一.配置步骤 1.安装vsftp 使用yum命令安装vsftp #yum install vsftpd -y 2.添加ftp帐号和目录 先确定nologin的位置,通常在/usr/sbin/nolog ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
